<?php
 if ( ! function_exists( 'gold_setup' ) ) :
	 /**
	  * Sets up theme defaults and registers support for various WordPress features.
	  *
	  * Note that this function is hooked into the after_setup_theme hook, which runs
	  * before the init hook. The init hook is too late for some features, such as indicating
	  * support post thumbnails.
	  */
	 function gold_setup() {

	 	if ( ! isset( $content_width ) ) $content_width = 900;

	 	/**
	 	 * Make theme available for translation
	 	 * Translations can be filed in the /languages/ directory
	 	 * If you're building a theme based on _s, use a find and replace
	 	 * to change 'gold_v-child' to the name of your theme in all the template files
	 	 */
	 	load_theme_textdomain( 'gold', get_template_directory() . '/languages' );

	 	/**
	 	 * Add default posts and comments RSS feed links to head
	 	 */
	 	add_theme_support( 'automatic-feed-links' );

	 	add_theme_support( 'custom-background', apply_filters( 'gold_background_args', array(
	 		'default-color' => 'ffffff',
	 		'default-image' => '',
	 	) ) );
	 	
	 	wp_link_pages( );

	 	/**
	 	 * Enable support for Post Thumbnails on posts and pages
	 	 *
	 	 * @link http://codex.wordpress.org/Function_Reference/add_theme_support#Post_Thumbnails
	 	 */
	 	//add_theme_support( 'post-thumbnails' );

	 	/**
	 	 * This theme uses wp_nav_menu() in one location.
	 	 */
	 	
	 	/**
	 	 * Enable support for Post Formats
	 	 */
	 	//add_theme_support( 'post-formats', array( 'aside', 'image', 'video', 'quote', 'link' ) );

	 	/**
	 	 * Setup the WordPress core custom background feature.
	 	 */
	 	
	 	 /*
	 	   Core Functions.
	 	 */
	 	 add_theme_support( 'post-thumbnails' ); 

	 	
	 		 //add_action('wp_head', 'show_template');
	 		 function show_template() {
	 		     global $template;
	 		     echo basename($template);
	 		 }
	 	
	 	/*****************Register Menus****************/

	 		 register_nav_menu( 'top_menu', 'Top Menu' );

	 		 register_nav_menu( 'main_menu', 'Main Menu' );

	 		 register_nav_menu('footer_sidebar_menu','Footer Sidebar Menu');

	 		 register_nav_menu('footer_menu','Footer Menu');

	 	/*****************Register Menus****************/

	 	/*****************Register Sidebar****************/	 

	 		 register_sidebar( array(

	 				'name' => __( 'Main Sidebar','Gold'),

	 				'id' => 'sidebar-1',

	 				'before_widget'=>'<div class="panel panel-default overflow" id="my-sidebar">',

	 				'after_widget'=>'</div>',

	 				'before_title' => '<div class="panel-heading"><h3 class="panel-title">',

	 				'after_title' => '</h3></div>',

	 			) );
	 		 
	 	 		register_sidebar( array(

	  	 		 		'name' => __( 'Footer Sidebar','Gold'),

	  	 		 		'id' => 'footer-sidebar',

	  	 		 		'before_widget'=>'<div class="col-lg-3 col-sm-6 col-xs-12 footer-widget"> <div class="footer-box">',

	  	 		 		'after_widget'=>'</div></div>',

	  	 		 		'before_title' => '<h4 class="footer-box-title">',

	  	 		 		'after_title' => '</h4><hr>',

	  	 		 	) );
	 	/*****************Register Sidebar****************/	 
	 }
 endif; 
 add_action( 'after_setup_theme', 'gold_setup' );

 

  if ( is_singular() ) wp_enqueue_script( "comment-reply" ); 

 	
 function gold_scripts(){

 		wp_enqueue_style('bootstrap',get_template_directory_uri().'/css/bootstrap.css');

		wp_enqueue_style('font-awesome',get_template_directory_uri().'/font-awesome/css/font-awesome.min.css');

		wp_enqueue_style('fonts',get_template_directory_uri().'/fonts/fonts.css');

		wp_enqueue_style('bootstrap-glyphicons',get_template_directory_uri().'/css/bootstrap-glyphicons.css');
		

		wp_enqueue_style('style',get_stylesheet_uri());

		wp_enqueue_style('helpers',get_template_directory_uri().'/css/helpers.css');


		wp_enqueue_script('bootstrap.js',get_template_directory_uri().'/js/bootstrap.min.js',array('jquery'),'',true);

		wp_enqueue_script('respond.min',get_template_directory_uri().'/js/respond.min.js',array('jquery'),'',true);

		wp_enqueue_script('gold-custom',get_template_directory_uri().'/js/gold-custom.js',array('jquery'),'',true);

 	}
 	add_action('wp_enqueue_scripts','gold_scripts');
	
	function gold_custom_style(){

        	$theme=of_get_option('default_theme');
            if($theme=='Default')
            {
            	wp_enqueue_style('default',get_template_directory_uri().'/css/default.css');
     
            }
            elseif($theme=='Basic')
            {
     			wp_enqueue_style('basic',get_template_directory_uri().'/css/basic.css');       	
            }
            elseif($theme=='Dark Blue')
            {
            	wp_enqueue_style('default-new',get_template_directory_uri().'/css/default-new.css');
            }
            else
            {
            	wp_enqueue_style('default',get_template_directory_uri().'/css/default.css');
            }	
            if(of_get_option('default_bg')!=''):
              $bg=of_get_option('default_bg');   
              echo '<style type="text/css">';
              echo 'body{';
              echo 'background: '.$bg['color'].' url("'.$bg['image'].'") '. $bg['repeat']." ".$bg['position']." ".$bg['attachment'];
              echo '}';
              echo '</style>';
            endif;
    }
	
	add_action('wp_enqueue_scripts','gold_custom_style'); 
 /**
 * Adds custom classes to the array of body classes.
 */
function body_classes( $classes ) {
   // Adds a class of group-blog to blogs with more than 1 published author
		if(is_home())
		{
			$classes[] = 'home-page';
		}
		if(is_page('gallery'))
		{
			$classes[] = 'gallery';	
		}
		if(is_page('services'))
		{
			$classes[] = 'Services';	
		}
	return $classes;
}
add_filter('body_class','body_classes');




 

/*

 * Class Name: wp_bootstrap_navwalker

 * GitHub URI: https://github.com/twittem/wp-bootstrap-navwalker

 * Description: A custom WordPress nav walker class to implement the Twitter Bootstrap 2.3.2 navigation style in a custom theme using the WordPress built in menu manager.

 * Version: 1.4.3

 * Author: Edward McIntyre - @twittem

 * License: GPL-2.0+

 * License URI: http://www.gnu.org/licenses/gpl-2.0.txt

 */



class wp_bootstrap_navwalker extends Walker_Nav_Menu {



	/*

		 * @see Walker::start_lvl()

		 * @since 3.0.0

		 *

		 * @param string $output Passed by reference. Used to append additional content.

		 * @param int $depth Depth of page. Used for padding.

	 */

		function start_lvl( &$output, $depth=0,$args=array()) {

			$indent = str_repeat( "\t", $depth );

			$output	   .= "\n$indent<ul class=\"dropdown-menu\">\n";		

		}



	/*

		 * @see Walker::start_el()

		 * @since 3.0.0

		 *

		 * @param string $output Passed by reference. Used to append additional content.

		 * @param object $item Menu item data object.

		 * @param int $depth Depth of menu item. Used for padding.

		 * @param int $current_page Menu item ID.

		 * @param object $args

		 */



		function start_el( &$output, $item, $depth = 0, $args = array(), $id = 0 ) {

			global $wp_query;

			$indent = ( $depth ) ? str_repeat( "\t", $depth ) : '';



			/*

			 * Dividers & Headers

		     * ==================

			 * Determine whether the item is a Divider, Header, or regular menu item.

			 * To prevent errors we use the strcasecmp() function to so a comparison

			 * that is not case sensitive. The strcasecmp() function returns a 0 if 

			 * the strings are equal.

			 */

			if (strcasecmp($item->title, 'divider') == 0) {

				// Item is a Divider

				$output .= $indent . '<li class="divider">';

			} else if (strcasecmp($item->title, 'divider-vertical') == 0) {

				// Item is a Vertical Divider

				$output .= $indent . '<li class="divider-vertical">';

			} else if (strcasecmp($item->title, 'nav-header') == 0) {

				// Item is a Header

				$output .= $indent . '<li class="nav-header">' . esc_attr( $item->attr_title );

			} else {



				$class_names = $value = '';

				$classes = empty( $item->classes ) ? array() : (array) $item->classes;

				$classes[] = ($item->current) ? 'active' : '';

				$classes[] = 'menu-item-' . $item->ID;

				$class_names = join( ' ', apply_filters( 'nav_menu_css_class', array_filter( $classes ), $item, $args ) );



				if ($args->has_children && $depth > 0) {

					$class_names .= ' dropdown';

				} else if($args->has_children && $depth === 0) {

					$class_names .= ' dropdown';

				}



				$class_names = $class_names ? ' class="' . esc_attr( $class_names ) . '"' : '';



				$id = apply_filters( 'nav_menu_item_id', 'menu-item-'. $item->ID, $item, $args );

				$id = $id ? ' id="' . esc_attr( $id ) . '"' : '';



				$output .= $indent . '<li' . $id . $value . $class_names .'>';

	            if($args->has_children && $depth === 0 && $class_names='dropdown') 

				{

					$attributes = ! empty( $item->target )     ? ' target="' . esc_attr( $item->target     ) .'"' : '';

					$attributes .= ! empty( $item->xfn )        ? ' rel="'    . esc_attr( $item->xfn        ) .'"' : '';

					$attributes .= ! empty( $item->url )        ? ' href="#"' : '';

					$attributes .= ($args->has_children) 	    ? ' data-toggle="dropdown" data-target="#" class="dropdown-toggle"' : '';



					$item_output = $args->before;

				}

				else

				{

					$attributes = ! empty( $item->target )     ? ' target="' . esc_attr( $item->target     ) .'"' : '';

					$attributes .= ! empty( $item->xfn )        ? ' rel="'    . esc_attr( $item->xfn        ) .'"' : '';

					$attributes .= ! empty( $item->url )        ? ' href="'   . esc_attr( $item->url        ) .'"' : '';

					$attributes .= ($args->has_children) 	    ? ' data-toggle="dropdown" data-target="#" class="dropdown-toggle"' : '';



					$item_output = $args->before;

	            }

				/*

				 * Glyphicons

				 * ===========

				 * Since the the menu item is NOT a Divider or Header we check the see

				 * if there is a value in the attr_title property. If the attr_title

				 * property is NOT null we apply it as the class name for the glyphicon.

				 */

				if(! empty( $item->attr_title )){

					$item_output .= '<a'. $attributes .'><i class="' . esc_attr( $item->attr_title ) . '"></i>&nbsp;';

				} else {

					$item_output .= '<a'. $attributes .'>';

				}



				$item_output .= $args->link_before . apply_filters( 'the_title', $item->title, $item->ID ) . $args->link_after;

				$item_output .= ($args->has_children && $depth == 0) ? ' <span class="caret"></span></a>' : '</a>';

				$item_output .= $args->after;



				$output .= apply_filters( 'walker_nav_menu_start_el', $item_output, $item, $depth, $args );

			}

		}



		/*

		 * Traverse elements to create list from elements.

		 *

		 * Display one element if the element doesn't have any children otherwise,

		 * display the element and its children. Will only traverse up to the max

		 * depth and no ignore elements under that depth. 

		 *

		 * This method shouldn't be called directly, use the walk() method instead.

		 *

		 * @see Walker::start_el()

		 * @since 2.5.0

		 *

		 * @param object $element Data object

		 * @param array $children_elements List of elements to continue traversing.

		 * @param int $max_depth Max depth to traverse.

		 * @param int $depth Depth of current element.

		 * @param array $args

		 * @param string $output Passed by reference. Used to append additional content.

		 * @return null Null on failure with no changes to parameters.

		 */



		function display_element( $element, &$children_elements, $max_depth, $depth, $args, &$output ) {

	        if ( !$element ) {

	            return;

	        }



	        $id_field = $this->db_fields['id'];



	        //display this element

	        if ( is_object( $args[0] ) ) {

	           $args[0]->has_children = ! empty( $children_elements[$element->$id_field] );

	        }



	        parent::display_element($element, $children_elements, $max_depth, $depth, $args, $output);

	    }

}



add_filter( 'comment_form_defaults', 'comment_textarea_filter', 9 );



function comment_textarea_filter( $fields ){

	$fields['comment_field'] = '<div class="well">'. $fields['comment_field']. '</div>';

	return $fields;

}


/*
 *  Shortcodes for tab ans collapse.
*/
	include('contactform.php');	
/*
   *************Option Framework Functions*********************
*/
   if ( !function_exists( 'optionsframework_init' ) ) {
   	define( 'OPTIONS_FRAMEWORK_DIRECTORY', get_template_directory_uri() . '/inc/' );
   	require_once dirname( __FILE__ ) . '/inc/options-framework.php';
   }

   /* 
    * This is an example of how to add custom scripts to the options panel.
    * This one shows/hides the an option when a checkbox is clicked.
    *
    * You can delete it if you not using that option
    */
   	
   add_action('optionsframework_custom_scripts', 'optionsframework_custom_scripts');

   function optionsframework_custom_scripts() { ?>

	   <script type="text/javascript">
	   jQuery(document).ready(function() {

	   	jQuery('#example_showhidden').click(function() {
	     		jQuery('#section-example_text_hidden').fadeToggle(400);
	   	});
	   	
	   	if (jQuery('#example_showhidden:checked').val() !== undefined) {
	   		jQuery('#section-example_text_hidden').show();
	   	}

	   	jQuery('#video_hidden').click(function() {
	     		jQuery('#section-show_video_hidden').fadeToggle(400);
	     		jQuery('#section-show_image_hidden').hide();
	     		jQuery('#image_hidden').prop('checked',false);
	     		
	    });
	    
	    if (jQuery('#video_hidden:checked').val() !== undefined) {
	    	jQuery('#section-show_video_hidden').show();
	    }
	    jQuery('#image_hidden').click(function() {
	     		jQuery('#section-show_image_hidden').fadeToggle(400);
	     		jQuery('#section-show_video_hidden').hide();
	     		jQuery('#video_hidden').prop('checked',false);	
	     		
	    });
	    if (jQuery('#image_hidden:checked').val() !== undefined) {
	    	jQuery('#section-show_image_hidden').show();
	    }

	    jQuery('#enable').click(function() {
      		jQuery('#section-rss').fadeToggle(400);
   	    	jQuery('#section-flicker').fadeToggle(400);
   	    	jQuery('#section-fb').fadeToggle(400);
   	    	jQuery('#section-twitter').fadeToggle(400);
   	    	jQuery('#section-youtube').fadeToggle(400);
   	    	jQuery('#disable').prop('checked',false);
	      		
	    });
	     
	    if(jQuery('#enable:checked').val() !== undefined) {
     		jQuery('#section-rss').show();
   	    	jQuery('#section-flicker').show();
   	    	jQuery('#section-fb').show();
   	    	jQuery('#section-twitter').show();
   	    	jQuery('#section-youtube').show();
	    }

	    
	   

	    jQuery('#preset').click(function() {
	       		if(jQuery('#preset').prop('checked',true))
	       		{
	       			jQuery('#custom').prop('checked',false)	
	       		}
	    });

	    jQuery('#custom').click(function() {
	       		if(jQuery('#custom').prop('checked',true))
	       		{
	       			jQuery('#preset').prop('checked',false)	
	       		}
	    });


	    jQuery('#single_btn').click(function() {
      		jQuery('#section-btntxt').fadeToggle(400);
	        jQuery('#section-modal-title').fadeToggle(400);
	        jQuery('#section-modal-content').fadeToggle(400);
	        jQuery('#section-btntxt1').hide();
	        jQuery('#section-modal-title1').hide();
	        jQuery('#section-modal-content1').hide();
    		jQuery('#section-btntxt2').hide();
    		jQuery('#section-btnlink2').hide();
    		jQuery('#two_btn').prop('checked',false);
	      		
	    });
	     
	    if(jQuery('#single_btn:checked').val() !== undefined) {
	     	jQuery('#section-btntxt').show();
	     	jQuery('#section-modal-title').show();
	        jQuery('#section-modal-content').show();
	     	jQuery('#section-btntxt1').hide();
    		jQuery('#section-modal-title1').hide();
	        jQuery('#section-modal-content1').hide();
    		jQuery('#section-btntxt2').hide();
    		jQuery('#section-btnlink2').hide();
	    }

   	    jQuery('#two_btn').click(function() {
         	
	        jQuery('#section-btntxt1').fadeToggle(400);
	        jQuery('#section-modal-title1').fadeToggle(400);
	        jQuery('#section-modal-content1').fadeToggle(400);
    		jQuery('#section-btntxt2').fadeToggle(400);
    		jQuery('#section-btnlink2').fadeToggle(400);
    		jQuery('#section-btntxt').hide();
	        jQuery('#section-modal-title').hide();
	        jQuery('#section-modal-content').hide();
    		jQuery('#single_btn').prop('checked',false);
   	      		
   	    });
   	     
   	    if(jQuery('#two_btn:checked').val() !== undefined) {
   	     	jQuery('#section-btntxt1').show();
	        jQuery('#section-modal-title1').show();
	        jQuery('#section-modal-content1').show();
    		jQuery('#section-btntxt2').show();
    		jQuery('#section-btnlink2').show();
    		jQuery('#section-btntxt').hide();
	        jQuery('#section-modal-title').hide();
	        jQuery('#section-modal-content').hide();
   	    }
	           
	    jQuery('#id-active li').click(function(){
	    		jQuery('#id-active li').removeClass('current');
	    		jQuery(this).addClass('current');
	    });	 

	    

	    jQuery('#box-1').click(function() {
      		jQuery('#section-b1_title').fadeToggle(400);
      		jQuery('#section-b1_editor').fadeToggle(400);
      		jQuery('#d-box-1').prop('checked',false);
	      		
	    });
	     
	    if(jQuery('#box-1:checked').val() !== undefined) {
	     	jQuery('#section-b1_title').show();
	     	jQuery('#section-b1_editor').show();
	    }

	    jQuery('#d-box-1').click(function() {
      		jQuery('#section-b1_title').hide();
      		jQuery('#section-b1_editor').hide();
      		jQuery('#box-1').prop('checked',false);
	      		
	    });
	     
	    if(jQuery('#d-box-1:checked').val() !== undefined) {
	     	jQuery('#section-b1_title').hide();
	     	jQuery('#section-b1_editor').hide();
	    }


	    jQuery('#box-2').click(function() {
      		jQuery('#section-b2_title').fadeToggle(400);
      		jQuery('#section-b2_editor').fadeToggle(400);
      		jQuery('#section-collapse_title1').hide();
      		jQuery('#section-example_collapse1').hide();
      		jQuery('#section-collapse_title2').hide();
      		jQuery('#section-example_collapse2').hide();
      		jQuery('#section-collapse_title3').hide();
      		jQuery('#section-example_collapse3').hide();
      		jQuery('#d-box-2').prop('checked',false);
	      		
	    });
	     
	    if(jQuery('#box-2:checked').val() !== undefined) {
	     	jQuery('#section-b2_title').show();
	     	jQuery('#section-b2_editor').show();
	     	jQuery('#section-collapse_title1').hide();
      		jQuery('#section-example_collapse1').hide();
      		jQuery('#section-collapse_title2').hide();
      		jQuery('#section-example_collapse2').hide();
      		jQuery('#section-collapse_title3').hide();
      		jQuery('#section-example_collapse3').hide();
	    }

	    jQuery('#d-box-2').click(function() {
      		jQuery('#section-b2_title').hide();
      		jQuery('#section-b2_editor').hide();
      		jQuery('#section-collapse_title1').fadeToggle(400);
      		jQuery('#section-example_collapse1').fadeToggle(400);
      		jQuery('#section-collapse_title2').fadeToggle(400);
      		jQuery('#section-example_collapse2').fadeToggle(400);
      		jQuery('#section-collapse_title3').fadeToggle(400);
      		jQuery('#section-example_collapse3').fadeToggle(400);
      		jQuery('#box-2').prop('checked',false);
	      		
	    });
	     
	    if(jQuery('#d-box-2:checked').val() !== undefined) {
	     	jQuery('#section-b2_title').hide();
	     	jQuery('#section-b2_editor').hide();
	     	jQuery('#section-collapse_title1').show();
      		jQuery('#section-example_collapse1').show();
      		jQuery('#section-collapse_title2').show();
      		jQuery('#section-example_collapse2').show();
      		jQuery('#section-collapse_title3').show();
      		jQuery('#section-example_collapse3').show();
	    }

	    jQuery('#box-3').click(function() {
      		jQuery('#section-b3_title').fadeToggle(400);
      		jQuery('#section-b3_editor').fadeToggle(400);
      		jQuery('#d-box-3').prop('checked',false);
	      		
	    });
	     
	    if(jQuery('#box-3:checked').val() !== undefined) {
	     	jQuery('#section-b3_title').show();
	     	jQuery('#section-b3_editor').show();
	    }
	    jQuery('#d-box-3').click(function() {
      		jQuery('#section-b3_title').hide();
      		jQuery('#section-b3_editor').hide();
      		jQuery('#box-3').prop('checked',false);
	      		
	    });
	     
	    if(jQuery('#d-box-3:checked').val() !== undefined) {
	     	jQuery('#section-b3_title').hide();
	     	jQuery('#section-b3_editor').hide();
	    }
		   
	  });
	</script>
<?php
}
/* 
 * **********Function End.********************
*/

/**
 * Custom template tags for this theme.
 *
 * Eventually, some of the functionality here could be replaced by core features
 *
 * @package _s
 */

if ( ! function_exists( 'gold_pager' ) ) :
/**
 * Display navigation to next/previous pages when applicable
 */
function gold_pager( $nav_id ) {
	global $wp_query, $post;

	// Don't print empty markup on single pages if there's nowhere to navigate.
	if ( is_single() ) {
		$previous = ( is_attachment() ) ? get_post( $post->post_parent ) : get_adjacent_post( false, '', true );
		$next = get_adjacent_post( false, '', false );

		if ( ! $next && ! $previous )
			return;
	}

	// Don't print empty markup in archives if there's only one page.
	if ( $wp_query->max_num_pages < 2 && ( is_home() || is_archive() || is_search() ) )
		return;

	$nav_class = ( is_single() ) ? 'post-navigation' : 'paging-navigation';

	?>
	<nav role="navigation" id="<?php echo esc_attr( $nav_id ); ?>" class="<?php echo $nav_class; ?>">

	<?php if ( is_single() ) : // navigation links for single posts ?>
		<ul class="pager">
					<?php previous_post_link( '<li class="previous">%link</li>', '<span class="meta-nav">' . _x( '&larr;', 'Previous post link', '_s' ) . '</span> %title' ); ?>
					<?php next_post_link( '<li class="next">%link</li>', '%title <span class="meta-nav">' . _x( '&rarr;', 'Next post link', '_s' ) . '</span>' ); ?>
		</ul>

	<?php elseif ( $wp_query->max_num_pages > 1 && ( is_home() || is_archive() || is_search() ) ) : // navigation links for home, archive, and search pages ?>

		<?php if ( get_next_posts_link() ) : ?>
		<div class="nav-previous"><?php next_posts_link( __( '<span class="meta-nav">&larr;</span> Older posts', '_s' ) ); ?></div>
		<?php endif; ?>

		<?php if ( get_previous_posts_link() ) : ?>
		<div class="nav-next"><?php previous_posts_link( __( 'Newer posts <span class="meta-nav">&rarr;</span>', '_s' ) ); ?></div>
		<?php endif; ?>

	<?php endif; ?>

	</nav><!-- #<?php echo esc_html( $nav_id ); ?> -->
	<?php
}
endif; // gold_pager



/**
	****Widgets Registration****
*/

/*****Widget For Address*****/	
	class wp_address extends WP_Widget {

		function __construct() {
			$widget_ops = array('classname' => 'widget_address', 'description' => __('Widget for add one of your address.','Gold'));
			$control_ops = array('width' => 300, 'height' => 350);
			parent::__construct('address', __('Gold Address Widget','Gold'), $widget_ops, $control_ops);
		}

		// widget form creation
		function form($instance) {

		// Check values
		     $title=isset( $instance['title'] ) ? esc_attr( $instance['title'] ) : '';
		?>

		<p>
		<span>You can update the address from Gold Options->Contact Page.</span><br><br>
		<label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Widget Title', 'wp_widget_plugin'); ?></label>
		<input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" />
		</p>
		<?php
		}

		// update widget
		function update($new_instance, $old_instance) {
		      $instance = $old_instance;
		      // Fields
		      $instance['title'] = strip_tags($new_instance['title']);
		     return $instance;
		}

		// display widget
		function widget($args, $instance) {
		   extract( $args );
		   // these are the widget options
		   $title = apply_filters('widget_title', $instance['title']);
		   echo $before_widget;
		   // Display the widget
		   // Check if title is set
		   if ( $title ) {
		      echo $before_title . $title . $after_title;
		   }
		   else{
		   		echo $before_title . 'Address'. $after_title;
		   }
		?>   <div class="wp-address">
		    <address>
         <?php 
          if(of_get_option('cmp')!=''):
            echo ' <strong>'.of_get_option('cmp').'</strong><br>';
          else:
             echo ' <strong>Your Company Name, Inc.</strong><br>';
          endif;
          ?>
           <?php 
            if(of_get_option('street')!=''):
              echo of_get_option('street').'<br>';
            else:
               echo 'Street Name<br>';
            endif;
          ?>
           <?php 
            if(of_get_option('city')!=''):
              echo of_get_option('city').'<br>';
            else:
               echo 'City Name, State,Country<br>';
            endif;
          ?>
          <?php 
            if(of_get_option('phno')!=''):
              echo '<a href="callto:000000000">'.of_get_option('phno').'</a>';
            else:
               echo '<a href="callto:000000000"> (XXX) XXX-XXXX </a>';
            endif;
          ?>
      </address>      
      <address>
          <?php 
            if(of_get_option('name')!=''):
              echo '<strong>'.of_get_option('name').'</strong><br>';
            else:
               echo '<strong>Full Name</strong><br>';
            endif;
          ?>
          <?php 
            if(of_get_option('eid')!=''):
              echo '<a href="mailto:#">'.of_get_option('eid').'</a>';
            else:
               echo '<a href="mailto:#">Your Email-Id</a>';
            endif;
    ?>
        
      </address> 
      </div>  
		<?php   echo $after_widget;
		}

		
	}

	// register widget
	add_action('widgets_init', create_function('', 'return register_widget("wp_address");'));

/*****End Of Widget For Address*****/


/*****Widget For Footer Recent Post*****/
	class wp_my_plugin extends WP_Widget {

		function __construct() {
			$widget_ops = array('classname' => 'widget_recent_entries', 'description' => __( "The most Footer Recent Post on your site",'Gold') );
			parent::__construct('footer-pecent-post', __('Gold View Recent Posts in The Footer','Gold'), $widget_ops);
			$this->alt_option_name = 'widget_recent_entries';

			
		}

		function widget($args, $instance) {
			

			ob_start();
			extract($args);

			$title = ( ! empty( $instance['title'] ) ) ? $instance['title'] : __( 'Footer Recent Post','Gold' );
			$title = apply_filters( 'widget_title', $title, $instance, $this->id_base );
			$number = ( ! empty( $instance['number'] ) ) ? absint( $instance['number'] ) : 10;
			if ( ! $number )
	 			$number = 10;
			$show_date = isset( $instance['show_date'] ) ? $instance['show_date'] : false;

			$r = new WP_Query( apply_filters( 'widget_posts_args', array( 'posts_per_page' => $number, 'no_found_rows' => true, 'post_status' => 'publish', 'ignore_sticky_posts' => true ) ) );
			if ($r->have_posts()) :
			?>
			<?php echo $before_widget; ?>
			<?php 
				if ( $title ) 
					echo $before_title . $title . $after_title; 
				else
					echo $before_title . 'Recent Posts' . $after_title;

			?>
			<ul class="nav nav-pills nav-stacked">
			<?php while ( $r->have_posts() ) : $r->the_post(); ?>
				<li>
					<a href="<?php the_permalink() ?>" title="<?php echo esc_attr( get_the_title() ? get_the_title() : get_the_ID() ); ?>"><span class="badge pull-right"><?php the_time('j M');?></span><?php if ( get_the_title() ) the_title(); else the_ID(); ?></a>
				</li>
			<?php endwhile; ?>
			</ul>
			<?php echo $after_widget; ?>
			<?php
			// Reset the global $the_post as this query will have stomped on it
			wp_reset_postdata();

			endif;

			$cache[$args['widget_id']] = ob_get_flush();
			wp_cache_set('widget_recent_posts', $cache, 'widget');
		}

		function update( $new_instance, $old_instance ) {
			$instance = $old_instance;
			$instance['title'] = strip_tags($new_instance['title']);
			$instance['number'] = (int) $new_instance['number'];
			$instance['show_date'] = isset( $new_instance['show_date'] ) ? (bool) $new_instance['show_date'] : false;
			$alloptions = wp_cache_get( 'alloptions', 'options' );
			if ( isset($alloptions['widget_recent_entries']) )
				delete_option('widget_recent_entries');

			return $instance;
		}

		

		function form( $instance ) {
			$title     = isset( $instance['title'] ) ? esc_attr( $instance['title'] ) : '';
			$number    = isset( $instance['number'] ) ? absint( $instance['number'] ) : 5;
			$show_date = isset( $instance['show_date'] ) ? (bool) $instance['show_date'] : false;
	?>
			<p><label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e( 'Title:','Gold' ); ?></label>
			<input class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo $title; ?>" /></p>

			<p><label for="<?php echo $this->get_field_id( 'number' ); ?>"><?php _e( 'Number of posts to show:' ,'Gold'); ?></label>
			<input id="<?php echo $this->get_field_id( 'number' ); ?>" name="<?php echo $this->get_field_name( 'number' ); ?>" type="text" value="<?php echo $number; ?>" size="3" /></p>

			<p><input class="checkbox" type="checkbox" <?php checked( $show_date ); ?> id="<?php echo $this->get_field_id( 'show_date' ); ?>" name="<?php echo $this->get_field_name( 'show_date' ); ?>" />
			<label for="<?php echo $this->get_field_id( 'show_date' ); ?>"><?php _e( 'Display post date?','Gold' ); ?></label></p>
	<?php
		}
	}

	// register widget
	add_action('widgets_init', create_function('', 'return register_widget("wp_my_plugin");'));

/*****End Of Widget For Footer Recent Post*****/


?>